*** res_timing_timerfd.c.original	2011-05-16 20:52:09.840854809 +0400
--- res_timing_timerfd.c	2011-05-16 21:27:11.913926072 +0400
*************** static void timerfd_timer_ack(int handle
*** 163,174 ****
--- 163,189 ----
  	int read_result = 0;
  
  	do {
+ 		struct itimerspec timer_status;
+ 
+ 		if(timerfd_gettime(handle,&timer_status)) {
+ 			ast_log(LOG_ERROR, "Call to timerfd_gettime() error: %s\n", strerror(errno));
+ 			expirations = 0;
+ 			break;
+ 		}
+ 
+ 		if((timer_status.it_value.tv_sec == 0) && (timer_status.it_value.tv_nsec == 0)) {
+ 			ast_log(LOG_ERROR, "Call to timerfd_timer_ack() with disarmed timer - break now to avoiding deadlock!\n");
+ 			expirations = 0;
+ 			break;
+ 		}
+ 
  		read_result = read(handle, &expirations, sizeof(expirations));
  		if (read_result == -1) {
  			if (errno == EINTR || errno == EAGAIN) {
  				continue;
  			} else {
  				ast_log(LOG_ERROR, "Read error: %s\n", strerror(errno));
+ 				expirations = 0;
  				break;
  			}
  		}
